<?php

namespace Modules\Pp\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;

class CustomerPlanData extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'pp_customer_order_plans_data';
    protected $primaryKey = 'customer_order_plan_data_id';
    //public $incrementing = false;
    //protected $keyType = 'string';
    protected $fillable = [];
    protected static $logAttributes = [
        'customer_order_plan_data_id',
        'customer_order_plan_id',
        'order_data_id',
        'manufacturing_order_no',
        'product_id',
        'product_name',
        'quantity',
        'status',
        'production_schedule',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "pp_customer_order_plans_data";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}
