var start = moment().startOf('month');
var end = moment().endOf('month');

var from = start;
var to = end;

var fromDate = start;
var toDate = end;

var list1 = [];
var list2 = [];

var n = 1;
var x = 0;

$(document).ready(function () {
    $('#cumulativeTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "thdate" },
            { "data": "thPlan" },
            { "data": "thbalance" },
            { "data": "thRequired" },
            { "data": "thBalance2" },
        ],
    });
    requiredTotal();

    $("input").change(function(){
        getProductName();
    })




    $('#btnSavePlan').click(function (event) {
        event.preventDefault();

        var dat = 'ok';

        var Tabledata = new Array();
            $("#cumulativeTable tbody").find("tr").each(function () {
                var date = $(this).find("td").eq(0).html();
                console.log( $(this).find("td").eq(0).html());
                var required = $(this).find("td").find("input").eq(3).val();
                var balance = $(this).find("td").eq(4).html();

                Tabledata.push({Date:date, Required:required, Balance:balance});

            });

        console.log(Tabledata);

        if ($('#btnSavePlan').html() == "Save") {

            $.ajax({
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                type: "POST",
                url: '/pp/DCPlan/save',
                data:{_token: '{!! csrf_token() !!}',"data":dat},

                processData: false,
                contentType: false,
                cache: false,
                timeout: 800000,
                beforeSend: function () {

                },

                success: function (response) {
                    console.log(response);
                    if (response) {

                        showSuccessMessage("Collection plan details have been saved successfully...");

                    } else {
                        showErrorMessage();
                    }


                }, error: function (data) {
                    console.log('Something went wrong!');
                }


            });


        }

    });


    function cb(from, to) {

        fromDate=from.format('YYYY-MM-DD');
        toDate=to.format('YYYY-MM-DD');
        $('#dailyCollectionPlan-daterangepicker span').html(from.format('MMMM D, YYYY') + ' - ' + to.format('MMMM D, YYYY'));

        var dates=datesRange(from,to);
        getRequired();
        loadPlan();

        $('#cumulativeTable tbody').html("");

        $.each(dates, function (index, value){
        });

    }


    $('#dailyCollectionPlan-daterangepicker').daterangepicker({
        startDate: start,
        endDate: end,
        opens: $('body').hasClass('rtl') ? 'right' : 'left',
        ranges: {
            'Today': [moment(), moment()],
            'Yesterday': [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
            'Last 7 Days': [moment().subtract(6, 'days'), moment()],
            'Last 30 Days': [moment().subtract(29, 'days'), moment()],
            'This Month': [moment().startOf('month'), moment().endOf('month')],
            'Last Month': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
        }
    }, cb);

    cb(from, to);

    // $('#cumulativeTable').DataTable({
    //     "ordering":  false,
    //     "searching": false,
    //     "paging": false,
    //     "info": false,
    //     columnDefs: [
    //         { width: 230, targets: 1 },
    //         { width: 230, targets: 2 },
    //         { width: 230, targets: 3 }
    //     ],
    // });

    $.ajax({
        type: 'GET',
        url: '/pp/DCPlan/searchMaterial',
        success: function (response) {
            console.log(response);
            if (response) {
                $("#txtMaterial"). setData(response);
                loadPlan();
            } else {
                showErrorMessage();

            }
        },
        error: function (data) {
            console.log(error);
                showErrorMessage();
        },
            complete: function () {

            }
    });


});

function datesRange(start,end){
    end=end.add(+1, 'days');
    var dates = [];
    while(start.format('M/D/YYYY') !== end.format('M/D/YYYY')) {
        dates.push(start.format('YYYY-M-D'));
        start = start.add(1, 'days');
      }
      return dates;

}


/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}


/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}


/**
* getPName
* Function for Auto Complete to fill other fields by enter the Name Field.
*/
function getProductName() {
    $.ajax({
        type: 'GET',
        url: '/pp/DCPlan/getPName/' + $('#txtMaterial').optionID(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
           if (response) {
                $('#txtProductID').val(response.product_id);
            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            showErrorMessage();
            console.log(data);
        },
        complete: function () {
        }
    });

}



/**
* getRequired
* Function for Auto Complete to fill other fields by enter the Name Field.
*/
function getRequired() {
    var id=$('#txtMaterial').optionID();
    $.ajax({
        type: 'GET',
        url: '/pp/DCPlan/Quantity/Product/'+id+'/from/'+fromDate+'/to/'+toDate,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {

            console.log(response.result);

            if (response.success) {

                var data = [];
                for (i = 0; i < response.result.length; i++) {
                    var date = response.result[i]['date'];
                    var required = response.result[i]['material'];


                        data.push({
                            "thdate": date,
                            "thPlan": required,
                            "thbalance": '',
                            "thRequired":  '<input value='+required+'  >',
                            "thBalance2":'',
                        });

                }

                var table = $('#cumulativeTable').DataTable();
                table.clear();
                table.rows.add(data).draw();
            }


        //    if (response) {

        //        $('#txtRequired').val(response[0].Required);


        //     } else {
        //         showErrorMessage();
        //     }
        },

        error: function (data) {
            console.log(data);
        },
        complete: function () {
        }
    });

}

function loadPlan() {

    var id=$('#txtMaterial').optionID();

    $.ajax({
        type: 'GET',
        url: '/pp/DCPlan/RequiredPlan/'+id+'/from/'+fromDate+'/to/'+toDate,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
        console.log(response);

            if (response) {

            for (var i = 0; i < response.length; i++)  {

            $('#cumulativeTable tbody').append('<tr> <td>' + response[i].selected_date+ '</td> <td>' + response[i].Plan+ '</td><td>' + response[i].Balance+ '</td> <td><input class="form-control auto-complete amount" autocomplete="off" placeholder="" required="" value="' + response[i].Plan+ '" ></td><td id="total">' + response[i].Balance+ '</td> </tr>');
            }
            } else {
                showErrorMessage();
            }
        },

        error: function (data) {
            console.log(data);
        },
        complete: function () {
        }
    });

}


function requiredTotal(){
$('#cumulativeTable tbody').on("keyup", ".amount", function () {
    var sum = 0;
    $('.amount').each(function () {
        sum += Number($(this).val());
        alert(sum);
        $('table tbody').find('td').eq(4).text(+sum);
    });
});
}


